/*
 * @(#)addresses.h	1.4  9/24/87
 */
#ifndef addresses_h
#define addresses_h

#ifndef regdefs_h
#include "regdefs.h"
#endif

#define Register 31
#define Local regs_l
#define Global regs_g
#define Stack regs_sp

typedef struct Address {
  unsigned int	base:5;
  unsigned int	autoIncrement:1;
  unsigned int	autoDecrement:1;
  unsigned int	hasIndex:1;
  unsigned int	indexReg:4;
  unsigned int  baseIsTemporary:1;
  unsigned int  indexIsTemporary:1;
  unsigned int	unused:2;
  short int	offset;
} Address;
extern Address nullAddress;
#endif
