/*
 * @(#)trace.h	1.7  1/20/89
 */
#ifndef trace_h
#define trace_h

extern int 	traceenvironment,
		traceemit,
		traceemitmove,
		traceallocate,
		tracehelp,
		traceimports,
		traceatctsort,
		traceassign,
		tracetempstack,
		tracetempreg,
		tracepasses,
		tracekernel,
		tracemanifest,
		traceconform,
		traceconformfailure,
		tracehandler,
		tracegraph,
		tracematchat,
		tracedoto,
		tracebuiltins,
		tracelocals,
		traceknowct,
		traceknowmanifest,
		traceknowlocal,
		tracegenerate,
		traceinvoccache,
		tracedelay,
		tracecopy,
		traceprimitive,
		tracelinenumber,
		tracetypecheck,
		tracedebuginfo;

extern void trace();

#ifdef lint
#   define IFTRACE(t, level) \
	if (level)
#   define TRACE0(t, level, format) \
	if (level) trace(level, format)
#   define TRACE1(t, level, format, arg1) \
	if (level) trace(level, format, arg1)
#   define TRACE2(t, level, format, arg1, arg2) \
	if (level) trace(level, format, arg1, arg2)
#   define TRACE3(t, level, format, arg1, arg2, arg3) \
	if (level) trace(level, format, arg1, arg2, arg3)
#   define TRACE4(t, level, format, arg1, arg2, arg3, arg4) \
	if (level) trace(level, format, arg1, arg2, arg3, arg4)
#   define TRACE5(t, level, format, arg1, arg2, arg3, arg4, arg5) \
	if (level) trace(level, format, arg1, arg2, arg3, arg4, arg5)
#else
#if defined(__ANSI__) || defined(__GNUC__)
#   define IFTRACE(t, level) \
	if (trace##t >= level)
#   define TRACE0(t, level, format) \
	if (trace##t >= level) trace(level, format)
#   define TRACE1(t, level, format, arg1) \
	if (trace##t >= level) trace(level, format, arg1)
#   define TRACE2(t, level, format, arg1, arg2) \
	if (trace##t >= level) trace(level, format, arg1, arg2)
#   define TRACE3(t, level, format, arg1, arg2, arg3) \
	if (trace##t >= level) trace(level, format, arg1, arg2, arg3)
#   define TRACE4(t, level, format, arg1, arg2, arg3, arg4) \
	if (trace##t >= level) trace(level, format, arg1, arg2, arg3, arg4)
#   define TRACE5(t, level, format, arg1, arg2, arg3, arg4, arg5) \
	if (trace##t >= level) trace(level, format, arg1, arg2, arg3, arg4, arg5)
#else
#   define IFTRACE(t, level) \
	if (trace/**/t >= level)
#   define TRACE0(t, level, format) \
	if (trace/**/t >= level) trace(level, format)
#   define TRACE1(t, level, format, arg1) \
	if (trace/**/t >= level) trace(level, format, arg1)
#   define TRACE2(t, level, format, arg1, arg2) \
	if (trace/**/t >= level) trace(level, format, arg1, arg2)
#   define TRACE3(t, level, format, arg1, arg2, arg3) \
	if (trace/**/t >= level) trace(level, format, arg1, arg2, arg3)
#   define TRACE4(t, level, format, arg1, arg2, arg3, arg4) \
	if (trace/**/t >= level) trace(level, format, arg1, arg2, arg3, arg4)
#   define TRACE5(t, level, format, arg1, arg2, arg3, arg4, arg5) \
	if (trace/**/t >= level) trace(level, format, arg1, arg2, arg3, arg4, arg5)
#endif
#endif
#endif
