/*
 * @(#)error.h	1.2  3/18/87
 */
#ifndef error_h
#define error_h
#ifndef NULL
#include <stdio.h>
#endif
#ifndef scan_h
#include "scan.h"
#endif

extern int numberOfSyntaxErrors, numberOfSemanticErrors;
extern char error_buffer[];
#define BeginErrorMessage(p) \
    { \
	fprintf(stdout, "\"%s\", line %d: ", \
	    currentFileName, (p)->lineNumber); \
	numberOfSemanticErrors++; \
    }
#define BeginWarningMessage(p) \
    { \
	fprintf(stdout, "\"%s\", line %d: (warning) ", \
	    currentFileName, (p)->lineNumber); \
    }
#define ErrorWrite(A) fprintf(stdout, A)
#define EndErrorMessage() fprintf(stdout, ".\n")

extern void BeginSyntaxErrorMessage();
extern void NotImplemented(/* p, s */);
/* NodePtr p; char *s; */
extern void CheckForErrors();
extern void ErrorMessage(/* p, s */);
/* NodePtr p; char *s; */
extern void WarningMessage(/* p, s */);
/* NodePtr p; char *s; */
extern int errno, sys_nerr;
extern char *sys_errlist[];
#endif
