/*
 * @(#)evaluate.h	1.2  3/18/87
 */
#ifndef evaluate_h
#define evaluate_h

#ifndef nodes_h
#include "nodes.h"
#endif

extern NodePtr evaluateForAT();
extern void evaluateManifest();
extern void evaluateATLit(), evaluateOBLit(), executeImports();
extern void evaluate(/* fNodePtr, needAT, inExpression, fValuePtr */);
/* NodePtr fNodePtr; Boolean needAT, inExpression; ValuePtr fValuePtr; */

extern NodePtr findATSignature(/* at, opName */);
/* NodePtr at, opName; */

extern NodePtr findObjectOperation(/* obj, opName */);
/* NodePtr obj, opName; */

extern void executeInvocation(/* targetValue, opName, arguments, value*/);
/* ValuePtr targetValue, value; NodePtr opName, arguments; */

extern Boolean conforms(/* fAT1, fAT2 */);
/* NodePtr fAT1, fAT2; */

extern Boolean matches(/* fAT1, fAT2 */);
/* NodePtr fAT1, fAT2; */

extern void checkConforms(/* fAT1, fAT2, fNodePtr */);
/* NodePtr fAT1, fAT2, fNodePtr; */

extern NodePtr figureOutAT(/* fNodePtr */);
/* NodePtr fNodePtr; */

extern Boolean isAnAT(/* fNodePtr */);
/* NodePtr fNodePtr; */

extern void declare(/* fSym */);
/* Symbol fSym; */

extern void typeCheck(/* fNodePtr */);
/* NodePtr fNodePtr; */
extern void doASetq();
extern Boolean duringExecution();
extern OID OIDOf();
#endif
