/*
 * @(#)keyword.c	1.2  3/18/87
 */
#include "assert.h"
#include "ident.h"
#include "keyword.h"
#include "tokens.h"

char **keywordTable;

void Keyword_Initialize()
{
    register int i;
    register Ident id;
    register char *c;

    keywordTable = &tokenNameTable[firstKeyword - 256];
    for (i = firstKeyword; i <= lastKeyword; i++) {
	c = keywordTable[i - firstKeyword];
	id = Ident_Lookup(c, strlen(c));
	assert (id == i - firstKeyword);
	lastKeywordIdent = id;
    }
}
